<template>
    <div class="home">
        <q-page class="row justify-evenly home-background-content">
            <div class="home-page-content">
                <div class="top-nav-bar">
                    <div
                        class="
                            row
                            q-pa-md q-py-md-md q-py-xs-sm
                            home-page-title
                        "
                    >
                        <!-- DESKTOP VIEW -->
                        <div
                            class="
                                row
                                items-center
                                col-5 col-md-12 col-lg-12
                                gt-sm
                            "
                        >
                            <div
                                class="
                                    title
                                    row
                                    justify-center
                                    items-center
                                    text-center
                                "
                            >
                                <p
                                    class="
                                        title-text
                                        helvetica-neue-medium
                                        font-24
                                    "
                                >
                                    {{ $t('home.header') }}
                                </p>
                            </div>

                            <select-filter
                                class="branch-filter row items-center q-pl-lg"
                                :header="`Branch`"
                                :branchData="business?.branches"
                                :selectedBranch="state.selectedBranch"
                                :reset="state.reset"
                                @update-confirm="updateBranch"
                            />

                            <div class="tab-title">
                                <q-tabs
                                    v-model="tab"
                                    class="items-center headerTabs"
                                    active-color="none"
                                    dense
                                    indicator-color="transparent"
                                    align="center"
                                    narrow-indicator
                                >
                                    <!-- Chatting Pool -->
                                    <div class="chats-container">
                                        <span
                                            class="new-force-conversation-badge"
                                            v-if="notifyStatus"
                                        ></span>
                                        <q-tab
                                            class="
                                                row
                                                justify-center
                                                tab-menu
                                                items-center
                                            "
                                            flat
                                            no-caps
                                            name="chatting"
                                            :label="$t('home.chats')"
                                            items-center
                                            @click="selectTab('chatting')"
                                        />
                                    </div>
                                    <!-- Ongoing -->
                                    <q-tab
                                        class="
                                            row
                                            justify-center
                                            tab-menu
                                            items-center
                                        "
                                        flat
                                        no-caps
                                        name="ongoing"
                                        :label="$t('home.ongoing')"
                                        items-center
                                        @click="selectTab('ongoing')"
                                    />

                                    <!-- All Clients -->
                                    <q-tab
                                        class="
                                            row
                                            justify-center
                                            tab-menu
                                            items-center
                                        "
                                        flat
                                        no-caps
                                        name="clients"
                                        :label="$t('home.clients')"
                                        items-center
                                        @click="selectTab('clients')"
                                    />

                                    <!-- Appointments -->
                                    <!-- <q-tab
                                        class="
                                            row
                                            justify-center
                                            tab-menu
                                            items-center
                                        "
                                        flat
                                        no-caps
                                        name="appointments"
                                        :label="$t('home.appointments')"
                                        items-center
                                        @click="selectTab('appointments')"
                                    /> -->
                                </q-tabs>
                            </div>
                            <div class="row items-center q-pl-xl gt-sm">
                                <auto-assign />
                            </div>
                        </div>
                        <!-- <div class="col-2 row justify-end items-center gt-sm">
                            <auto-assign />
                        </div>-->
                        <div
                            class="
                                col-1
                                row
                                justify-center
                                items-center
                                q-pr-lg
                                gt-sm
                            "
                        >
                            <notifications />
                        </div>

                        <!-- Note Drawer Button Desktop -->
                        <div
                            v-if="tab == 'ongoing'"
                            class="note-drawer-desktop"
                        >
                            <q-btn
                                class="note-drawer-button"
                                flat
                                text-color="white"
                                icon="edit"
                                @click="openNoteDrawer(true)"
                            />
                        </div>

                        <!-- MOBILE VIEW -->
                        <div class="row items-center col-2 lt-md">
                            <q-btn
                                flat
                                round
                                @click="openMenu(true)"
                                icon="menu"
                            />
                        </div>
                        <div
                            class="
                                row
                                items-center
                                col-5 col-md-2 col-lg-2
                                lt-md
                            "
                        >
                            <div
                                class="
                                    title
                                    row
                                    justify-center
                                    items-center
                                    text-center
                                "
                            >
                                <p
                                    class="
                                        title-text
                                        helvetica-neue-medium
                                        font-24
                                    "
                                >
                                    {{ $t('home.header') }}
                                </p>
                            </div>
                        </div>
                        <div class="col-5 row justify-end items-center lt-md">
                            <auto-assign
                                class="row justify-end q-mt-sm items-center"
                            />
                        </div>

                        <!-- <div
                            class="col-2 row justify-center items-center lt-md"
                        >
                            <notifications
                                class="row justify-end q-mt-sm items-center"
                            />
                        </div> -->

                        <!-- <div class="col-5 lt-md mobile-filter">
                            <select-filter
                                class="
                                    branch-filter
                                    row
                                    items-center
                                    q-pl-md-lg q-pl-sm-md
                                "
                                :header="`Branch`"
                                :branchData="business?.branches"
                                :selectedBranch="state.selectedBranch"
                                :reset="state.reset"
                                @update-confirm="updateBranch"
                            />
                        </div> -->

                        <!-- Setting Drawer Button -->
                        <div class="setting-drawer-position lt-md">
                            <q-btn
                                class="setting-drawer-button"
                                flat
                                text-color="white"
                                icon="tune"
                                @click="openSettingDrawer(true)"
                            />
                        </div>

                        <!-- Ongoing Drawer Button -->
                        <div
                            v-if="tab == 'ongoing'"
                            class="ongoing-drawer-position lt-md"
                        >
                            <q-btn
                                class="ongoing-drawer-button"
                                flat
                                text-color="white"
                                icon="view_list"
                                @click="openOngoingDrawer(true)"
                            />
                        </div>

                        <!-- Note Drawer Button Mobile -->
                        <div
                            v-if="tab == 'ongoing'"
                            class="note-drawer-position lt-md"
                        >
                            <q-btn
                                class="note-drawer-button"
                                flat
                                text-color="white"
                                icon="edit"
                                @click="openNoteDrawer(true)"
                            />
                        </div>

                        <!-- <div
                            class="
                                col-12 col-md-5
                                q-pl-md-md
                                row
                                justify-start
                                items-center
                                tab-title
                                lt-md
                            "
                        >
                            <q-tabs
                                v-model="tab"
                                class="items-center headerTabs"
                                active-color="none"
                                dense
                                indicator-color="transparent"
                                align="center"
                                narrow-indicator
                            > -->
                        <!-- Chatting Pool -->
                        <!-- <q-tab
                                    class="
                                        row
                                        justify-center
                                        tab-menu
                                        items-center
                                    "
                                    flat
                                    no-caps
                                    name="chatting"
                                    :label="$t('home.chats')"
                                    items-center
                                    @click="selectTab('chatting')"
                                /> -->

                        <!-- Ongoing -->
                        <!-- <q-tab
                                    class="
                                        row
                                        justify-center
                                        tab-menu
                                        items-center
                                    "
                                    flat
                                    no-caps
                                    name="ongoing"
                                    :label="$t('home.ongoing')"
                                    items-center
                                    @click="selectTab('ongoing')"
                                /> -->

                        <!-- All Clients -->
                        <!-- <q-tab
                                    class="
                                        row
                                        justify-center
                                        tab-menu
                                        items-center
                                    "
                                    flat
                                    no-caps
                                    name="clients"
                                    :label="$t('home.clients')"
                                    items-center
                                    @click="selectTab('clients')"
                                /> -->

                        <!-- Appointments -->
                        <!-- <q-tab
                                    class="
                                        row
                                        justify-center
                                        tab-menu
                                        items-center
                                    "
                                    flat
                                    no-caps
                                    name="appointments"
                                    :label="$t('home.appointments')"
                                    items-center
                                    @click="selectTab('appointments')"
                                />
                            </q-tabs>
                        </div> -->
                    </div>
                    <div class="q-px-md">
                        <q-tab-panels
                            v-model="tab"
                            animated
                            class="bg-transparent"
                        >
                            <!-- All Chat -->
                            <q-tab-panel
                                name="chatting"
                                class="border-radius-20 q-pa-none"
                            >
                                <all-chat
                                    :requestConversationButton="
                                        requestConversationButtonPressed
                                    "
                                    :transferConversationButton="
                                        transferConversationButtonPressed
                                    "
                                    :ticketIDLink="ticketIDLinkPressed"
                                    @allChatConversation="allChatConversation"
                                    @ticket-id-state="ticketIdState"
                                />
                            </q-tab-panel>

                            <!-- Ongoing -->
                            <q-tab-panel name="ongoing" class="q-pa-none">
                                <div class="row">
                                    <div
                                        class="col-12 col-md-3 col-lg-3 ongoing"
                                    >
                                        <!-- Request List -->
                                        <ongoing-issue />
                                    </div>

                                    <div
                                        id="chatbox-container"
                                        class="
                                            chatbox-container
                                            col-12 col-md-9 col-lg-9
                                            no-scroll
                                        "
                                    >
                                        <conversation-list
                                            @openSearchBox="openSearch"
                                            @updateList="conversationIssueType"
                                            @filesSelected="onFilesSelected"
                                            @submit="onSubmit"
                                            :tab="tab"
                                        />
                                        <transition name="fade">
                                            <div
                                                v-if="isShowPreview"
                                                class="chat-area-preview show"
                                            >
                                                <div
                                                    class="
                                                        body
                                                        bg-blur-white
                                                        col
                                                        column
                                                    "
                                                >
                                                    <preview-upload
                                                        :key="files.length"
                                                        :files="files"
                                                        @close="
                                                            isShowPreview = false
                                                        "
                                                        @update="onFilesUpdated"
                                                    />
                                                </div>
                                            </div>
                                        </transition>
                                    </div>

                                    <div id="searchBox" class="searchBox">
                                        <!-- Search Input -->
                                        <div
                                            class="
                                                row
                                                items-center
                                                justify-center
                                            "
                                        >
                                            <div
                                                class="col-10 col-lg-11 q-pa-sm"
                                            >
                                                <q-input
                                                    v-model="search"
                                                    outlined
                                                    :label="
                                                        $t(
                                                            'preference.searchMessage'
                                                        )
                                                    "
                                                    debounce="500"
                                                    bg-color="transparent"
                                                    dense
                                                    class="border-radius-10"
                                                >
                                                    <template v-slot:prepend>
                                                        <q-icon
                                                            name="search"
                                                            class="text-5B9ADD"
                                                        />
                                                    </template>
                                                </q-input>
                                            </div>
                                            <div class="col-2 col-lg-1">
                                                <q-btn
                                                    flat
                                                    round
                                                    text-color="black"
                                                    size="md"
                                                    icon="clear"
                                                    @click="closeSearch"
                                                />
                                            </div>
                                        </div>

                                        <!-- Search Result -->
                                        <template
                                            v-if="
                                                state.searchMessageList.length >
                                                0
                                            "
                                        >
                                            <message-list-item
                                                v-for="(
                                                    message, index
                                                ) in state.searchMessageList"
                                                :key="message.id"
                                                :conversation="conversation"
                                                :message="message"
                                                :previousMessage="
                                                    index > 0
                                                        ? state
                                                              .searchMessageList[
                                                              index - 1
                                                          ]
                                                        : null
                                                "
                                                class="chatbox-contain"
                                                :searchResult="true"
                                            />
                                        </template>
                                        <template v-else>
                                            <p class="q-pa-md">No Result</p>
                                        </template>
                                    </div>
                                </div>
                            </q-tab-panel>

                            <!-- All Client -->
                            <q-tab-panel
                                name="clients"
                                class="all-clients no-scroll q-pa-none"
                            >
                                <all-client
                                    :requestConversationButton="
                                        requestConversationButtonPressed
                                    "
                                    :transferConversationButton="
                                        transferConversationButtonPressed
                                    "
                                    @allClientConversation="
                                        allClientConversation
                                    "
                                    :ticketIDLink="ticketIDLinkPressed"
                                />
                            </q-tab-panel>

                            <!-- Appointments-->
                            <q-tab-panel
                                name="appointments"
                                class="appointments no-scroll q-pa-none"
                            >
                                <appointment
                                    :requestConversationButton="
                                        requestConversationButtonPressed
                                    "
                                    :transferConversationButton="
                                        transferConversationButtonPressed
                                    "
                                    @allClientConversation="
                                        allClientConversation
                                    "
                                    :ticketIDLink="ticketIDLinkPressed"
                                />
                            </q-tab-panel>
                        </q-tab-panels>
                    </div>
                </div>
            </div>
            <!-- User Selection Modal (Transfer to XXX ) -->
            <user-selection
                v-model="state.confirm"
                :convId="state.convId"
                :ticketId="state.ticketId"
                :currentIndex="state.currentIndex"
                :issuesType="state.issuesType"
                :tab="tab"
                @update-confirm="updateConfirm"
                @update-convId="updateConvID"
                :conversationOwner="state.conversationOwner"
            />
        </q-page>
    </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-explicit-any*/
/* eslint-disable @typescript-eslint/no-floating-promises */
/* eslint-disable @typescript-eslint/no-misused-promises */
/* eslint-disable @typescript-eslint/require-await */
import { useStore } from 'src/store';
import {
    defineComponent,
    ref,
    reactive,
    watch,
    onMounted,
    computed
} from 'vue';
import { mapGetters } from 'vuex';
import { date, useQuasar } from 'quasar';
import OngoingIssue from 'src/components/chats/OngoingIssue.vue';
import SelectFilter from 'src/components/chats/SelectFilter.vue';
import ConversationList from 'src/components/chats/ConversationList.vue';
import Appointment from 'src/components/chats/Appointment.vue';
import { MessageCreateRequestBody } from 'src/services/requests/message/MessageCreateRequest';
import { Message } from 'src/services/models/Message';
import { FilePreview } from 'src/services/models/FilePreview';
import { MessageType } from 'src/services/enums/MessageType';
import PreviewUpload from 'src/components/modals/PreviewUpload.vue';
import Notifications from 'src/components/commons/Notifications.vue';
import AutoAssign from 'src/components/commons/AutoAssign.vue';
import { useRouter } from 'vue-router';
import AllChat from 'src/components/chats/AllChat.vue';
import AllClient from 'src/components/chats/AllClient.vue';
import UserSelection from 'src/components/modals/UserSelection.vue';
import { TabType } from 'src/services/enums/TabType';
import { useWindowSize } from 'vue-window-size';
import localForage from 'localforage';
import { debounce } from 'lodash';
import MessageListItem from 'src/components/chats/MessageListItem.vue';

export default defineComponent({
    name: 'Helpdesk',
    components: {
        // HistoryList,
        // RemarkList,
        ConversationList,
        PreviewUpload,
        Notifications,
        AutoAssign,
        OngoingIssue,
        AllClient,
        AllChat,
        UserSelection,
        SelectFilter,
        Appointment,
        MessageListItem
    },
    computed: {
        ...mapGetters({
            issueTypes: 'issueType/getIssueTypesList',
            selectedBusinessID: 'business/getBusinessID',
            user: 'user/getUser',
            business: 'business/getBusiness',
            menuDrawer: 'menu/getMenuDrawer',
            noteDrawer: 'menu/getNoteDrawer',
            ongoingDrawer: 'menu/getOngoingDrawer',
            notifyStatus: 'menu/getNotifyStatus'
        })
    },
    emits: ['updateList', 'openSearchBox'],
    setup() {
        // data
        const $q = useQuasar();
        const currentTime = date.formatDate(Date.now(), 'HH:mm:ss');
        let show = 1;
        const store = useStore();
        const router = useRouter();
        const { width, height } = useWindowSize();
        const branchStore = localForage.createInstance({
            name: 'lobbi/branch'
        });

        // data
        let tab = ref(
            store.state.menu.selectedShortcut == 'business' ||
                store.state.menu.selectedShortcut == 'helpdesk'
                ? 'chatting'
                : store.state.menu.selectedShortcut
        );

        let search = ref('');
        let state = reactive({
            selectedUser: ref(''),
            conversation: [] as any,
            issuesType: [] as any,
            loadingState: ref(false),
            searchResults: ref(false),
            success: ref(false),
            error: ref(false),
            confirm: ref(false),
            convId: '' as string,
            ticketId: '' as string,
            currentIndex: 0,
            searchList: [] as any,
            searchMessageList: [] as any,
            historyList: [] as any,
            selectedAgent: {} as any,
            selectedClient: {} as any,
            selectedIssueType: {} as any,
            selectedStatus: {} as any,
            selectedBranch: {} as any,
            formatClients: [] as any,
            formatClientsConversation: [] as any,
            pagination: {
                page: 0,
                totalPage: 0,
                limit: 0,
                total: 0
            },
            currentPage: 1,
            client: [] as any,
            clientConversation: [] as any,
            route: router.currentRoute.value,
            reset: ref(false),
            allChatConversation: [] as any,
            allClientConversation: computed(() => {
                return store.state.conversation.allClient;
            }),
            branchList: computed(() => {
                return store.state.branch.branches;
            }),
            conversationOwner: ref(''),
            permissions: computed(() => {
                return store.state.role.permissions;
            })
        });

        const files = ref<FilePreview[]>([]);
        const isShowPreview = ref(false);
        const isShowDropzone = ref(false);
        const text = ref('');

        // computed
        const conversationState = computed(() => {
            return store.state.conversation;
        });
        const tabState = computed(() => {
            return store.state.menu.selectedShortcut;
        });
        const socketStatus = computed(() => {
            return store.state.conversation.socket;
        });

        const clients = computed(() => {
            return store.state.business.customer;
        });

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        // methods
        const reset = () => {
            state.selectedAgent = {};
            state.selectedClient = {};
            state.selectedIssueType = {};
            state.selectedStatus = {};
            state.reset = true;
            setTimeout(() => {
                state.reset = false;
            }, 3000);
        };

        const updateFilter = (value: any, header: any) => {
            if (header == 'Agent') {
                state.selectedAgent = value;
            } else if (header == 'Client') {
                state.selectedClient = value;
            } else if (header == 'Issue Type') {
                state.selectedIssueType = value;
            } else if (header == 'Status') {
                if (value.name == 'All') {
                    state.selectedStatus = '';
                } else {
                    state.selectedStatus = value;
                }
            }
        };

        const getIssueTypeByBusinessID = () => {
            // reset issue type
            state.issuesType = [];

            const result = store.state.issueType.issueTypes;

            if (result.length > 0) {
                result.forEach((issue: any) => {
                    let issues = {
                        id: issue.id,
                        name: issue.name,
                        list: [] as any
                    };
                    state.issuesType.push(issues);
                });
            }
        };

        const formatConversations = (conversations: any) => {
            state.formatClientsConversation = [];
            state.clientConversation = conversations;

            conversations.forEach((conversation: any) => {
                let agentName = '-';
                let agentID = null;

                if (conversation.agent) {
                    agentName = conversation.agent.name;
                    agentID = conversation.agent.id;
                }

                // If got transfer change status to pending
                if (conversation.transfer) {
                    conversation.status = 3;
                }

                // 0-WAITING, 1-ACTIVE, 2-CLOSED, 3-PENDING (Not inside api, custom status)
                let conversationStatus = '';
                switch (conversation.status) {
                    case 3:
                        conversationStatus = 'Pending';
                        break;
                    case 0:
                        conversationStatus = 'Waiting';
                        break;
                    case 1:
                        conversationStatus = 'Active';
                        break;
                    case 2:
                        conversationStatus = 'Closed';
                        break;
                }

                state.client = { name: conversation.user.name };
                let time = date.formatDate(
                    conversation.updatedAt,
                    'YYYY-MM-DD'
                );

                state.formatClientsConversation.push({
                    dateTime: time,
                    ticketId: conversation.referenceNo,
                    issueType: conversation.issueType.name,
                    lastAgent: { name: agentName, id: agentID },
                    status: conversationStatus
                });
            });
        };

        const searchFunction = async (search: string) => {
            state.loadingState = true;
            const resultMessage: any = await store.dispatch('message/search', {
                keyword: search,
                conversationId:
                    store.state.conversation.selectedConversation?.id,
                branchId: store.state.branch.branch?.id,
                page: 1,
                limit: 10
            });

            if (resultMessage.messages.length > 0) {
                state.loadingState = false;
                state.searchMessageList = resultMessage.messages;
            } else {
                state.loadingState = false;
            }
        };

        const conversationIssueType = (conversationID: any, issueType: any) => {
            const filteredConversationList =
                conversationState.value.conversationsList.filter(
                    (conversation) => {
                        if (conversation.id == conversationID) {
                            (conversation.issueType.id = issueType.id),
                                (conversation.issueType.name = issueType.name);
                        }
                    }
                );
            return filteredConversationList;
        };

        const selectedConversation = (conversation: {
            id: string;
            user: { id: string };
        }) => {
            store.dispatch(
                'conversation/setSelectedConversationID',
                conversation.id
            );
            store.dispatch(
                'conversation/setSelectedUserID',
                conversation.user.id
            );

            if (conversation) {
                store.commit('chat/selectConversation', conversation);
            }
        };

        const selectUserConversation = (id: string, name: string) => {
            state.selectedUser = name;
            store.dispatch('conversation/setSelectedUserID', id);
        };

        const clearSelectedUserConversation = () => {
            store.dispatch('conversation/clearSelectedUserID');
        };

        const onSubmit = async (data: {
            body: MessageCreateRequestBody;
            repliedMessage?: Message;
        }) => {
            // Parse the text
            await store.dispatch('message/sendMessage', data);
        };

        const updateConfirm = (value: boolean) => {
            state.confirm = value;
            // set assign success state
            store.dispatch('conversation/setAssignSuccess', true);
        };

        const updateConvID = (value: string) => {
            state.convId = value;
        };

        const getConversationsTransferList = () => {
            if (
                store.getters['business/getBusiness']?.member.isOwner ||
                state.permissions?.conversation?.list == true
            ) {
                store.dispatch(
                    'conversation/getConversationsTransferList',
                    store.state.business.businessID
                );
            }
        };

        const onFilesSelected = (_files: FilePreview[]) => {
            files.value = [...files.value, ..._files];
            if (files.value.length > 10) {
                files.value.length = 10;
            }
            isShowPreview.value = true;
        };

        const onFileDrop = (e: any) => {
            isShowDropzone.value = false;
            let _files = files.value;

            _files = [
                ..._files,
                ...[...e.dataTransfer.files].map((file: File): FilePreview => {
                    let type = MessageType.DOCUMENT;
                    if (file.type.includes('image/')) {
                        type = MessageType.IMAGE;
                    } else if (file.type.includes('video/')) {
                        type = MessageType.VIDEO;
                    } else if (file.type.includes('audio/')) {
                        type = MessageType.AUDIO;
                    }

                    return {
                        file,
                        url: URL.createObjectURL(file),
                        type,
                        text: text.value
                    };
                })
            ];

            text.value = '';

            _files = _files.filter((file) => {
                if (file.type == MessageType.GIF) {
                    return true;
                }

                // Check if file readable
                if (!file.file) {
                    return false;
                }

                // Validate image
                if (file.type == MessageType.IMAGE) {
                    // Validate size
                    if (file.file.size > 1024 * 1024 * 5) {
                        return false;
                    }

                    // TODO - Validate unsupported format
                }

                // Validate audio
                if (file.type == MessageType.AUDIO) {
                    if (file.file.size > 1024 * 1024 * 20) {
                        return false;
                    }

                    // TODO - Validate unsupported format
                }

                // Validate video
                if (file.type == MessageType.VIDEO) {
                    if (file.file.size > 1024 * 1024 * 100) {
                        return false;
                    }

                    // TODO - Validate unsupported format
                }

                // Validate others
                if (file.file.size > 1024 * 1024 * 300) {
                    return false;
                }

                return true;
            });

            // Limit 5 media at a time
            if (_files.length > 10) {
                _files = _files.splice(0, 10);
            }

            // Show preview if files valid
            if (_files.length > 0) {
                files.value = _files;
                isShowPreview.value = true;
            } else {
                isShowPreview.value = false;
            }
        };

        const onFilesUpdated = (_files: FilePreview[]) => {
            files.value = _files;
            if (files.value.length > 10) {
                files.value.length = 10;
            }
        };

        const selectTab = debounce((page: string) => {
            router.push('/helpdesk');
            store.dispatch('menu/setSelectedShortcut', page);
            store.dispatch('chat/unselectConversation');
            store.dispatch('menu/setNoteDrawer', false);
            store.dispatch('conversation/clearSelectedConversationID');
            changeNotifyStatus();
        }, 500);

        const checkRoute = () => {
            setTimeout(async () => {
                if (router.currentRoute.value.path.includes('user', 1)) {
                    store.dispatch('menu/setSelectedShortcut', 'clients');
                    tab.value = 'clients';
                }

                if (router.currentRoute.value.path.includes('chat', 1)) {
                    store.dispatch('menu/setSelectedShortcut', 'ongoing');
                    tab.value = 'ongoing';
                }
            }, 500);
        };

        const selectPagePressed = (page: number) => {
            state.currentPage = page;
            if (state.client.name) {
                viewClientButtonPressed(router.currentRoute.value.params.id);
            }
        };

        const updateBranch = (currentValue: any) => {
            const findIndex = state.branchList.findIndex(
                (element: any) => element.id == currentValue.id
            );
            if (findIndex != -1) {
                branchStore.getItem('branchFilter').then(function (value: any) {
                    value.forEach((element: any) => {
                        if (element.businessId == selectedBusinessId.value) {
                            element.index = findIndex;
                            element.branchId = currentValue.id;
                            branchStore.setItem('branchFilter', value);
                        }
                    });
                });
            }
            store.dispatch('chat/unselectConversation');
            store.dispatch('message/reset');
            store.dispatch('note/clearNote');
            store.dispatch('conversation/clearSelectedConversation');
            store.dispatch('conversation/clearSelectedConversationID');
            router.push('/helpdesk');
            store.dispatch('branch/setBranch', currentValue);
        };

        const viewClientButtonPressed = async (id: any) => {
            if (!id) {
                id = router.currentRoute.value.params.id;
                state.currentPage = 1;
            }
            const result = await store.dispatch(
                'conversation/getOneConversation',
                {
                    userId: id,
                    isDownward: 0,
                    page: state.currentPage,
                    issueTypeIds: state.selectedIssueType.id,
                    statuses: state.selectedStatus.value,
                    agentId: state.selectedAgent.id
                }
            );

            formatConversations(result.conversations);
        };

        const back = () => {
            state.formatClientsConversation = [];
            state.client = [];
            state.currentPage = 1;
            router.push('/helpdesk');
        };

        const requestConversationButtonPressed = (ticketId: string) => {
            const conversation = getConversationDetails(ticketId);
            let result = {
                ticketId: ticketId,
                type: 'Request'
            };

            store.dispatch('conversation/setSelectedTicketID', result);
            store.dispatch('conversation/requestConversation', {
                conversationId: conversation[0]?.id
            });
        };

        const transferConversationButtonPressed = (ticketId: string) => {
            state.confirm = true;
            const conversation = getConversationDetails(ticketId);

            state.convId = conversation[0].id;
            if (conversation[0].referenceNo) {
                state.ticketId = conversation[0].referenceNo;
            } else {
                state.ticketId = conversation[0].ticketId;
            }
            state.conversationOwner = '';
            if (conversation[0].lastAgent) {
                state.conversationOwner = conversation[0].lastAgent.id;
            }
        };

        const ticketIDLinkPressed = (ticketId: any) => {
            const conversation = getConversationDetails(ticketId.ticketId);
            router.push({
                path: '/chat',
                query: {
                    conversationId: conversation[0].id,
                    businessId: store.state.business.businessID,
                    branchId: store.state.branch.branch.id
                }
            });
            store.dispatch('menu/setSelectedShortcut', 'ongoing');
            store.dispatch(
                'conversation/setTicketConversation',
                conversation[0]
            );
        };

        const getConversationDetails = (ticketId: string) => {
            if (tab.value == TabType.CHATTING) {
                return state.allChatConversation.filter((conversation: any) => {
                    return conversation.referenceNo == ticketId;
                });
            } else {
                return state.allClientConversation.filter(
                    (conversation: any) => {
                        return conversation.ticketId == ticketId;
                    }
                );
            }
        };

        const allChatConversation = (data: any) => {
            state.allChatConversation = data.conversations;
        };
        const allClientConversation = (data: any) => {
            state.allClientConversation = data;
        };

        const openSearch = () => {
            if ($q.platform.is.desktop) {
                const searchStatus: HTMLElement | null =
                    document.getElementById('chatbox-container');
                searchStatus && (searchStatus.style.width = '45%');

                const searchBoxStatus: HTMLElement | null =
                    document.getElementById('searchBox');
                searchBoxStatus &&
                    (searchBoxStatus.style.width = '30%') &&
                    searchBoxStatus &&
                    (searchBoxStatus.style.display = 'block');
                return searchStatus && searchBoxStatus;
            } else {
                const searchStatus: HTMLElement | null =
                    document.getElementById('chatbox-container');
                searchStatus && (searchStatus.style.width = '0%');

                const searchBoxStatus: HTMLElement | null =
                    document.getElementById('searchBox');
                searchBoxStatus &&
                    (searchBoxStatus.style.width = '100%') &&
                    searchBoxStatus &&
                    (searchBoxStatus.style.display = 'block');
                return searchStatus && searchBoxStatus;
            }
        };

        const closeSearch = () => {
            if ($q.platform.is.desktop) {
                const searchStatus: HTMLElement | null =
                    document.getElementById('chatbox-container');
                searchStatus && (searchStatus.style.width = '75%');

                const searchBoxStatus: HTMLElement | null =
                    document.getElementById('searchBox');
                searchBoxStatus &&
                    (searchBoxStatus.style.width = 'unset') &&
                    searchBoxStatus &&
                    (searchBoxStatus.style.display = 'none');
                return searchStatus && searchBoxStatus;
            } else {
                const searchStatus: HTMLElement | null =
                    document.getElementById('chatbox-container');
                searchStatus && (searchStatus.style.width = '100%');

                const searchBoxStatus: HTMLElement | null =
                    document.getElementById('searchBox');
                searchBoxStatus &&
                    (searchBoxStatus.style.width = 'unset') &&
                    searchBoxStatus &&
                    (searchBoxStatus.style.display = 'none');
                return searchStatus && searchBoxStatus;
            }
        };

        const defaultStatus = () => {
            store.dispatch('menu/setNotify', false);
        };

        const changeNotifyStatus = () => {
            if (tab.value == 'ongoing') {
                store.dispatch('menu/setNotify', false);
            }
        };

        const setSelectedBranch = () => {
            state.selectedBranch = store.state.branch.branch;
        };

        const checkPermission = () => {
            if (!store.state.role.permissions.conversation?.list) {
                router.push('/');
            }
        };

        const getMembers = async () => {
            await store.dispatch('member/getList', {
                status: 1,
                branchIds: [store.state.branch.branch.id]
            });
        };

        const openMenu = (status: boolean) => {
            store.dispatch('menu/setMenuDrawer', status);
        };

        const openNoteDrawer = (status: boolean) => {
            store.dispatch('menu/setNoteDrawer', status);
        };

        const openOngoingDrawer = (status: boolean) => {
            store.dispatch('menu/setOngoingDrawer', status);
        };

        const openSettingDrawer = (status: boolean) => {
            store.dispatch('menu/setSettingDrawer', status);
        };

        const timerForNotification = () => {
            if (tab.value == 'chatting') {
                setTimeout(() => {
                    store.dispatch('menu/setNotify', false);
                }, 1000);
            }
        };

        // watch
        store.watch(
            (state) => state.chat.selectedConversation,
            () => {
                // Reset everything on switching conversation
                isShowPreview.value = false;
                isShowDropzone.value = false;
                files.value = [];
            }
        );

        store.watch(
            (state) => state.menu.notifyStatus,
            () => {
                timerForNotification();
            }
        );

        watch(selectedBusinessId, () => {
            if (selectedBusinessId.value) {
                // check permission
                checkPermission();

                // set selected branch object
                setSelectedBranch();
                defaultStatus();
            }
        });

        watch(state.issuesType, async (currentValue) => {
            if (currentValue) {
                await store.dispatch(
                    'conversation/setConversationLength',
                    currentValue
                );
            }
        });

        watch(tabState, async (currentValue) => {
            if (currentValue) {
                tab.value = currentValue;
                store.dispatch('conversation/setSelectedConversationID', '');
                timerForNotification();
            }
        });

        watch(search, async (currentValue) => {
            if (currentValue || currentValue != '') {
                state.searchList = [];
                state.searchMessageList = [];
                await searchFunction(currentValue);
            } else {
                state.loadingState = false;
                state.searchResults = false;
                state.searchList = [];
                state.searchMessageList = [];
            }
        });

        watch(router.currentRoute, async (to, from) => {
            if (to.params.id) {
                state.currentPage = 1;
                viewClientButtonPressed(to.params.id);
                checkRoute();
            }
        });

        // Mounted
        onMounted(checkPermission);
        onMounted(getIssueTypeByBusinessID);
        onMounted(getConversationsTransferList);
        onMounted(clearSelectedUserConversation);
        onMounted(checkRoute);
        onMounted(setSelectedBranch);
        onMounted(getMembers);

        return {
            tab,
            state,
            dense: ref(true),
            search,
            conversationIssueType,
            currentTime,
            show,
            selectedConversation,
            onSubmit,
            socketStatus,
            updateConfirm,
            updateConvID,
            onFilesSelected,
            isShowPreview,
            files,
            selectUserConversation,
            clearSelectedUserConversation,
            onFileDrop,
            onFilesUpdated,
            selectTab,
            selectPagePressed,
            viewClientButtonPressed,
            back,
            requestConversationButtonPressed,
            transferConversationButtonPressed,
            ticketIDLinkPressed,
            checkRoute,
            updateFilter,
            reset,
            allChatConversation,
            allClientConversation,
            windowWidth: width,
            getIssueTypeByBusinessID,
            updateBranch,
            openMenu,
            openNoteDrawer,
            openOngoingDrawer,
            openSettingDrawer,
            openSearch,
            closeSearch
        };
    }
});
</script>
